module Codebreaker
  class Console
    attr_accessor :game

    def initialize
      @game = Game.new
    end

    def play
      intro
      until game.completed?
        case answ = get_answer
          when /^[1-6]{4}/ then game.mark_user_code(answ)
          when /^[Hh]{1}/ then game.show_hint
          else puts 'You entered wrong value, pal. Try again'
        end
      end
      puts game.won? ? 'Great job! You guessed secret code!' : 'Oh, you exceed the number of available attempts'
      save_result_request
      play_again_request
    end

    private
    def intro
      puts 'Welcome to Codebreaker!'
      puts 'You need to break randomly generated secret code'
      puts 'You can input code or request hint(with H or h)'
      puts 'So, lets go!'
    end

    def save_result_request
      puts 'Do you wanna save result?'
      game.save_result if get_answer =~ /[Yy]/
    end

    def play_again_request
      puts 'Do you wanna play again?'
      return unless get_answer =~ /[Yy]/
      @game = Game.new
      system('clear')
      play
    end

    def get_answer
      gets.chomp
    end
  end
end